<?php

/*
 * $Id: export.php 5414 2015-02-20 13:20:10Z svnpeton $
 * charset: UTF-8
 * Remarque : impose la présence de iconv.
 */

// DEBUG (activation du debug)
$debug = false;
$ignore_signature = false;

if (isset ($_REQUEST['DEBUG']) and $_REQUEST['DEBUG'] == '1')
  $debug = true;

// Version module export.
if ($debug)
  define ('G_VERSION', '2.0.10dev');
else
  define ('G_VERSION', '2.0.10');

include_once('../../config/config.inc.php');
include_once('../../init.php');

if (!defined ('_PS_VERSION_'))
  exit;

include_once(dirname (__FILE__) . '/gulliver.php');

if (!ini_get ('safe_mode'))
{
  @set_time_limit (3600);
  @ini_set ('memory_limit', '512M');
}

if ($debug)
{
  ini_set ('display_errors', 1);
  error_reporting (E_ALL ^ E_NOTICE);
}
else
{
  ini_set ('display_errors', 0);
  error_reporting (E_ERROR);
}

define ('G_SEP', ';');
define ('G_EOL', "\n");

//
// TODO: Vérif du token Admin.
// $admin = new Gulliver (); // AdminGulliver ();
// echo $adminGulliver->token ();

$do2 = $_REQUEST['do2'];
if ($do2 == 'version')
{
  G_do_version ();
}

// Vérif du CRC/SHA1
if (get_magic_quotes_gpc ())
{
  $do = stripslashes ($_REQUEST['do']);
  $gmdate = stripslashes ($_REQUEST['gmdate']);
  $version = stripslashes ($_REQUEST['version']);
}
else
{
  $do = $_REQUEST['do'];
  $gmdate = $_REQUEST['gmdate'];
  $version = $_REQUEST['version'];
}

$api_key = Configuration::get ('MOD_GULLIVER_API_KEY');

$calc_signature = sha1 ("$gmdate$version$do$do2$api_key");
$signature = $_REQUEST['signature'];
if (!$ignore_signature and $signature != $calc_signature)
{
  if ($api_key == '' or $signature == '')
    die ('Signature not set');

  #if ($debug and isset ($_REQUEST['debug923']) and !empty ($gmdate))
  #  die ('Bad signature ' . "($calc_signature = sha1 ($gmdate$version$do$do2$api_key);");
  #else
  die ('Bad signature');
}

// Vérification de la date
$current_gmdate = gmdate ("Y-m-d\TH:i:s\Z");
$gmtime = strtotime ($gmdate);
$current_gmtime = strtotime ($current_gmdate);
if ($gmtime + 3600 < $current_gmtime - 600)
{
  die ('Bad date');
}

global $id_lang;
if (isset ($_REQUEST['select_id_lang']) && $_REQUEST['select_id_lang'] != '')
  $id_lang = $_REQUEST['select_id_lang'];
else
  $id_lang = intval (Configuration::get ('PS_LANG_DEFAULT'));

switch ($do2)
{
  case 'version2':
    G_do_version ('EXTENDED');
    break;
  case 'test':
    G_do_test ();
    break;
  case 'category':
    G_do_category ();
    break;
  case 'max_customer':
    G_do_maxIdCustomer ();
    break;
  case 'customer':
    G_do_customer ();
    break;
  case 'customer_sms':
    G_do_customer_sms ();
    break;
  case 'product':
    G_do_product ('EXTENDED'); // Avec le descriptif.
    break;
  case 'orders':
    G_do_orders ();
    break;
  case 'search_order':
    G_do_search_order ();
    break;
  case 'product_basic':
    G_do_product ('BASIC'); // Sans les descriptifs.
    break;
  case 'set_cart_rule':
    G_do_cat_rule ();
    break;
  case 'version': // Déjà traité en amont.
  default:
    G_do_version ();
    break;
}

die ('BAD DATA');

exit (0);

/* ------------------------------------------------------------------------------------------------------- */

function G_do_version ($info = 'BASIC')
{
  header ('Content-Type: text/plain; charset=iso-8859-1');
  // Version Export
  $page = "VERSION=" . G_VERSION . "\n";
  if ($info == 'EXTENDED')
  {
    // Version PrestaShop
    $page .= "PS_VERSION=" . _PS_VERSION_ . "\n";
    // Version Module Gulliver.
    $admin = new Gulliver (); // AdminGulliver ();
    $page .= "G_VERSION=" . $admin->getVersion () . "\n";

    // php version
    $page .= 'PHP_VERSION=' . phpversion () . "\n";
    if (function_exists ('apache_get_version'))
      $page .= 'APACHE_VERSION=' . apache_get_version () . "\n";

    $page .= 'php_display_errors=' . ini_get ('display_errors') . "\n";
    $page .= 'php_register_globals=' . ini_get ('register_globals') . "\n";
    $page .= 'php_post_max_size=' . ini_get ('post_max_size') . "\n";
    $page .= 'php_safe_mode=' . ini_get ('safe_mode') . "\n";
    $page .= 'php_memory_limit=' . ini_get ('memory_limit') . "\n";
    $page .= 'php_max_execution_time=' . ini_get ('memory_max_execution_time') . "\n";

    if (function_exists ('iconv'))
      $page .= 'iconv=1' . "\n";
  }

  echo utf8_decode ($page);

  exit (0);
}

function G_do_test ()
{
  header ('Content-Type: text/plain; charset=iso-8859-1');

  $page = "OK\n";

  echo utf8_decode ($page);

  exit (0);
}

function G_do_maxIdCustomer ()
{
  header ('Content-Type: text/plain; charset=iso-8859-1');

  $sql = 'select max(c.id_customer) as MAX from ' . constant ('_DB_PREFIX_') . 'customer c';
  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  $page = "MAX=" . $Tsql[0]['MAX'] . "\n";

  echo utf8_decode ($page);

  exit (0);
}

/**
 * Remarque : HASH supplémentaire sur les paramètres...
 */
function G_do_cat_rule ()
{
  $email = NULL;
  $id_customer = 0;
  $date_from = date ('Y-m-d H:i:s');
  $date_to = NULL;
  $quantity = 1;
  $quantity_per_user = 1;
  $priority = 1;
  $partial_use = 0;
  $active = 1;
  $code = NULL;
  //$reduction_percent = NULL;
  $reduction_val = NULL;
  $reduction_type = NULL;
  $product_restriction = 0;
  $reduction_product = NULL;

  if (isset ($_REQUEST['DATE_FROM']))
    $date_from = $_REQUEST['DATE_FROM'];
  if (isset ($_REQUEST['DATE_TO']))
    $date_to = $_REQUEST['DATE_TO'];
  if (empty ($date_to))
  {
    $date_to = date ('Y-m-d H:i:s', time () + 365 * 24 * 60 * 60);
  }
  if (isset ($_REQUEST['EMAIL']))
    $email = $_REQUEST['EMAIL'];
  if (isset ($_REQUEST['CODE']))
    $code = $_REQUEST['CODE'];
  #if (isset ($_REQUEST['REDUCTION_PERCENT']))
  #  $reduction_percent = $_REQUEST['REDUCTION_PERCENT'];
  if (isset ($_REQUEST['REDUCTION_VAL']))
    $reduction_val = $_REQUEST['REDUCTION_VAL'];
  if (isset ($_REQUEST['REDUCTION_TYPE']))
    $reduction_type = $_REQUEST['REDUCTION_TYPE'];
  if (isset ($_REQUEST['REF']))
    $reduction_product = $_REQUEST['REF'];

  $do2 = $_REQUEST['do2'];
  // Vérif du CRC/SHA1
  if (get_magic_quotes_gpc ())
  {
    $do = stripslashes ($_REQUEST['do']);
    $gmdate = stripslashes ($_REQUEST['gmdate']);
    $version = stripslashes ($_REQUEST['version']);
  }
  else
  {
    $do = $_REQUEST['do'];
    $gmdate = $_REQUEST['gmdate'];
    $version = $_REQUEST['version'];
  }
  $api_key = Configuration::get ('MOD_GULLIVER_API_KEY');
  $calc_signature2 = sha1 ("$gmdate$version$do$do2$code$email$reduction_val$reduction_type$reduction_product$api_key");
  $signature2 = $_REQUEST['signature2'];
  if ($signature2 != $calc_signature2)
  {
    if ($api_key == '' or $signature2 == '')
      die ('Signature not set');

    #if ($debug and isset ($_REQUEST['debug923']) and !empty ($gmdate))
    #  die ('Bad signature ' . "($calc_signature = sha1 ($gmdate$version$do$do2$api_key);");
    #else
    die ('Bad signature');
  }

  include_once 'classes/CartRule.php';

  // $isAvail = CartRule::isFeatureActive ();

  $id_rule = CartRule::getIdByCode ($code);

  if ($id_rule !== FALSE)
  {
    // Règle déjà existante !
    echo "ERR: Il existe déjà une règle (n°$id_rule) avec ce code promotion\n";
  }
  else
  {
    $cart_rule = new CartRule();
    if ($reduction_type == 'PERCENT')
      $cart_rule->description = "CYouSoon:$email:\n${reduction_val}%:" .  date ('Y-m-d H:i:s');
    else
      $cart_rule->description = "CYouSoon:$email:\n${reduction_val}€:" .  date ('Y-m-d H:i:s');
    $cart_rule->id_customer = $id_customer;
    $cart_rule->code = $code;
    $cart_rule->name = array(Configuration::get ('PS_LANG_DEFAULT') => 'Surprise CYouSoon'); // Language ...
    $cart_rule->date_from = $date_from;
    $cart_rule->date_to = $date_to;
    $cart_rule->priority = $priority;
    $cart_rule->partial_use = $partial_use;
    $cart_rule->quantity = $quantity;
    $cart_rule->quantity_per_user = $quantity_per_user;
    $cart_rule->minimum_amount_currency = 1; // 1
    $cart_rule->reduction_currency = 1; // TODO
    if ($reduction_type == 'PERCENT')
      $cart_rule->reduction_percent = $reduction_val;
    else
      $cart_rule->reduction_amount = $reduction_val;
    // $cart_rule->reduction_currency = 'EUR';
    $cart_rule->reduction_tax = 1; // 0:HT, 1:TTC
    // $cart_rule->reduction_product = $reduction_product; // id produit à trouver ?
    $cart_rule->product_restriction = $product_restriction;

    // $cart_rule->free_shipping = true;
    $cart_rule->active = $active;

    try
    {
      $cart_rule->add ();
    }
    catch (Exception $e)
    {
      var_dump ($e);
    }
    echo "ok2";
    exit;
  }
  exit (0);
}

function G_do_category ()
{
  global $id_lang;

  header ('Content-Type: text/csv; charset=iso-8859-1');
  header ('Content-Disposition: attachment; filename=export_category_' . date ('dmY') . '_' . date ('His') . '.csv');
  $Theader = array("EXTERNAL_REF_CAT", "NOM", "TXT", "EXTERNAL_REF_CAT_MERE", "VISIBLE");

  G_displayLine ($Theader);

  $sql = 'select c.id_category, c.id_parent, cl.name, cl.description, c.active ' .
          ' from ' . constant ('_DB_PREFIX_') . 'category c, ' . constant ('_DB_PREFIX_') . 'category_lang cl' .
          " where cl.id_lang = '$id_lang' and c.id_category = cl.id_category" .
          ' order by c.id_parent asc, c.id_category asc';

  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  $Tcategories = array();
  foreach ($Tsql as $T)
  {
    // On filtre les G$...
    if (preg_match ('/^G\$/', $T['name']))
      continue;

    $Tcategories[$T['id_category']] = $T;
  }
  unset ($Tsql);

  // Tri et affichage
  $Tparent = array(0);
  $Tcache = array(0 => true);
  do
  {
    $Tnew_parent = array();
    foreach ($Tcategories as $id_category => $Tcategory)
    {
      if (isset ($Tcache [$id_category]))
        continue;
      if (in_array ($Tcategory['id_parent'], $Tparent))
      {
        $Tcache [$id_category] = true;
        $Tnew_parent [] = $id_category;

        $Tdata = array();
        $Tdata[] = $Tcategory['id_category'];
        $Tdata[] = $Tcategory['name'];
        $Tdata[] = $Tcategory['description'];
        $Tdata[] = $Tcategory['id_parent'];
        $Tdata[] = $Tcategory['active'];

        G_displayLine ($Tdata);
        // unset( $Tcategories[$id_category] );
      }
    }
    $Tparent = $Tnew_parent;
  } while (count ($Tparent) > 0);

  exit (0);
}

function G_get_params_product ()
{
  $Tsql = array();

  if (isset ($_REQUEST['FROM_ID']))
  {
    $Tsql[] = 'p.id_product>=' . (int) $_REQUEST['FROM_ID'];
  }

  if (isset ($_REQUEST['TO_ID']))
  {
    $Tsql[] = 'p.id_product<=' . (int) $_REQUEST['TO_ID'];
  }

  return $Tsql;
}

function G_get_params_customer ()
{
  $Tsql = array();

  if (isset ($_REQUEST['FROM_ID']))
  {
    $Tsql[] = 'c.id_customer>=' . (int) $_REQUEST['FROM_ID'];
  }

  if (isset ($_REQUEST['TO_ID']))
  {
    $Tsql[] = 'c.id_customer<=' . (int) $_REQUEST['TO_ID'];
  }

  if (isset ($_REQUEST['DATE_FROM']))
  {
    $Tsql[] = 'c.date_add>=\'' . pSQL ($_REQUEST['DATE_FROM']) . '\'';
  }

  if (isset ($_REQUEST['DATE_TO']))
  {
    $Tsql[] = 'c.date_add<=\'' . pSQL ($_REQUEST['DATE_TO']) . '\'';
  }

  return $Tsql;
}

function G_get_params_order ()
{
  $Tsql = array();

  if (isset ($_REQUEST['DATE_FROM']))
  {
    $Tsql[] = 'o.date_add>=\'' . pSQL ($_REQUEST['DATE_FROM']) . '\'';
  }

  if (isset ($_REQUEST['DATE_TO']))
  {
    $Tsql[] = 'o.date_add<=\'' . pSQL ($_REQUEST['DATE_TO']) . '\'';
  }

  return $Tsql;
}

/**
 * Option : FROM_ID, TO_ID, FROM_DATE, TO_DATE, ALL_DATA
 * @global type $id_lang
 */
function G_do_customer ()
{
  global $id_lang;

  $filter = true;
  if (isset ($_REQUEST['ALL_DATA']))
  {
    if ($_REQUEST['ALL_DATA'] == 1)
      $filter = false;
  }

  // selection de la langue des contacts à exporter (en fonction de leur pays de livraison)
  if (isset ($_REQUEST['select_lang_for_export_contact']))
    $lang_selected_for_export = $_REQUEST['select_lang_for_export_contact'];
  else
    $lang_selected_for_export = 'ALL';

  $Tsql = G_get_params_customer ();
  $Tsql[] = 'c.active = 1';
  $Tsql[] = 'c.deleted != 1';
  $where = join (' and ', $Tsql);

  // TODO: A vérifier : format CSV sans les guillemets ?
  header ('Content-Type: text/csv; charset=iso-8859-1');
  header ('Content-Disposition: attachment; filename=export_customer_' . date ('dmY') . '_' . date ('His') . '.csv');
  // $Theader = array("EMAIL", "LAST_NAME", "FIRST_NAME", "COMPANY", "DIVERS");
  // G_displayLine ($Theader);
  //REQUETE POUR RECUPERE LES INFOS "DE BASE" SUR LES CLIENTS
  // dans type_contact on récupère 1 si le client a passé au moins une commande / sinon NULL (permet de determiner client / prospect)
  $sql = 'select c.id_customer, c.email, c.id_gender, c.lastname, c.firstname, c.birthday, c.newsletter, c.optin,
          (select 1 from ' . constant ('_DB_PREFIX_') . 'orders o where o.valid=1 and o.id_customer=c.id_customer group by id_customer) as type_contact,
          (select id_lang from ' . constant ('_DB_PREFIX_') . 'orders o where o.valid=1 and o.id_customer=c.id_customer group by id_order desc limit 0,1) as order_id_lang
          ' .
          'from ' . constant ('_DB_PREFIX_') . 'customer c
          where ' . $where;

  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  /*
   *
    select c.id_customer, c.email, c.id_gender, c.lastname, c.firstname, c.birthday, c.newsletter, c.optin,
    (select 1 from ps_orders o where o.valid=1 and o.id_customer=c.id_customer group by id_customer) as type_contact
    from ps_customer c
    where c.active = 1 and c.deleted != 1 */

  //REQUETE POUR RECUPERER LES ADRESSES DES CLIENTS
  $sql2 = 'select id_customer, address1, address2, postcode, city, id_country, phone, phone_mobile ' .
          'from ' . constant ('_DB_PREFIX_') . 'address where active = 1 and deleted != 1';
  $Tsql2 = Db::getInstance ()->ExecuteS ($sql2);

  // TODO: Eviter de passer par un tableau

  foreach ($Tsql2 as $row)
  {
    $Tsql2a[$row['id_customer']] = $row;
  }
  $Tsql2 = $Tsql2a;
  $Tsql2a = null;

  //NOM DES COLONNES
  $Tentete_colonnes = Array();
  $Tentete_colonnes[] = 'EMAIL';
  $Tentete_colonnes[] = 'GENRE';
  $Tentete_colonnes[] = 'NOM';
  $Tentete_colonnes[] = 'PRENOM';

  $Tentete_colonnes[] = 'ADRESSE';
  $Tentete_colonnes[] = 'ADRESSE2';
  $Tentete_colonnes[] = 'CODE_POSTAL';
  $Tentete_colonnes[] = 'VILLE';
  $Tentete_colonnes[] = 'PAYS';
  $Tentete_colonnes[] = 'TELEPHONE';
  $Tentete_colonnes[] = 'MOBILE';
  $Tentete_colonnes[] = 'TYPE_CONTACT';

  $Tentete_colonnes[] = 'BIRTHDAY';
  $Tentete_colonnes[] = 'NEWSLETTER';
  $Tentete_colonnes[] = 'OPTIN';
  $Tentete_colonnes[] = 'STAMPS';
  //$Tentete_colonnes[] = '';
  G_displayLine ($Tentete_colonnes, false);

  //cette boucle concerne la table des clients de Prestashop (+ la table des adresses)
  $Temail_already_capted = Array();
  foreach ($Tsql as $T)
  {
    $Tdata = array();
    $Tdata[] = $T['email'];

    if ($T['id_gender'] == 1)
      $Tdata[] = 'MONSIEUR';
    else
      $Tdata[] = 'MADAME';

    $Tdata[] = $T['lastname'];
    $Tdata[] = $T['firstname'];

    $flag_adress_ok = FALSE;
    $country_customer = NULL;

    if (isset ($Tsql2[$T['id_customer']]))
    {
      $T2 = $Tsql2[$T['id_customer']];

      $flag_adress_ok = TRUE;
      $Tdata[] = $T2['address1'];
      $Tdata[] = $T2['address2'];
      $Tdata[] = $T2['postcode'];
      $Tdata[] = $T2['city'];
      $country_customer = G_get_gta_country_from_prestashop_id_country ($T2['id_country']);
      $Tdata[] = $country_customer;
      $Tdata[] = $T2['phone'];
      $Tdata[] = $T2['phone_mobile'];
    }

    if ($flag_adress_ok == FALSE)
    {
      $Tdata[] = '';
      $Tdata[] = '';
      $Tdata[] = '';
      $Tdata[] = '';
      $Tdata[] = '';
      $Tdata[] = '';
      $Tdata[] = '';
    }

    //si la personne a passé au moins une commande validée, alors c'est un client
    //sinon prospect
    if ($T['type_contact'] == 1)
      $Tdata[] = 'CLIENT';
    else
      $Tdata[] = 'PROSPECT';

    $Tdata[] = $T['birthday'];
    $Tdata[] = $T['newsletter'];
    $Tdata[] = $T['optin'];
    $Tdata[] = G_get_stamps ($T['id_customer']);
    //$Tdata[] = '';

    $Temail_already_capted[] = trim ($T['email']);

    //ON EXPORTE OU PAS ? => DEPEND DE LA LANGUE CHOISIE POUR L'EXPORT
    // I. On exporte pas si le client n'est pas inscrit a la newsletter + si il n'est pas optin (car contact inutile => on ne peut pas lui envoyer de mail)
    // II. Si client Optin ou Newsletter =>
    //       => 1) toutes les langues ont été séléctionnées pour l'export => dans tous les cas on exporte
    //       => 2) le client a déjà passé une commande => on a le order_id_lang
    //                        ssi le order_id_lang est le meme que la langue sélectionnée on exporte
    //       => 3) le client n'a pas passé de commande => on exporte seulement si "No language" selectionné
    if (!$filter or $T['newsletter'] != 0 or $T['optin'] != 0) //on exporte ssi OPTIN ou NEWSLETTER
    {
      if ($lang_selected_for_export == 'ALL')
      {
        G_displayLine ($Tdata, false);
      }
      else if ($T['order_id_lang'] != NULL)
      {
        //recuperer le code iso pays dans la table ps_lang a partir du order_id_lang
        $country_lang = strtoupper ((G_get_iso_code_from_id_lang_prestashop ($T['order_id_lang'])));

        //code iso == langue selectionnée => on exporte
        if ($country_lang == $lang_selected_for_export)
          G_displayLine ($Tdata, false);
      }
      else if ($T['order_id_lang'] == NULL)//client n'a pas passé commande => on exporte ssi "NO_LANGUAGE" selectionné
      {
        if ($lang_selected_for_export == 'NO_LANGUAGE')
          G_displayLine ($Tdata, false);
      }
    }
  }

  $Tsql = null;
  $Tsql2 = null;

  //REQUETE POUR RECUPERER LES ADRESSES DES INSCRITS A LA NEWSLETTER (un inscrit n'est pas forcément client, ni un contact !)
  //cas des inscrits a la newsletter
  //=> on ne connait pas leur pays => donc on les exporte => si "toutes" les langues sélectionnées pour export
  //
  if ($lang_selected_for_export == 'ALL' || $lang_selected_for_export == 'NO_LANGUAGE')
  {
    // Vérifier que la table existe...
    $sql3 = 'show tables like \'' . constant ('_DB_PREFIX_') . 'newsletter\'';
    $Tsql3 = Db::getInstance ()->ExecuteS ($sql3);
    if (count ($Tsql3) > 0)
    {
      // La table exite...  Charger les emails de la table newsletter.
      $sql3 = 'select email from ' . constant ('_DB_PREFIX_') . 'newsletter';
      $Tsql3 = Db::getInstance ()->ExecuteS ($sql3);
    }
    else
      $Tsql3 = null;

    //cette boucle concerne seulement les inscrits à la newsletter (table ps_newsletter de prestashop)
    //car on peut être inscrit à la newsletter et ne pas etre client => dans ce cas l'email n'est pas capté dans la boucle précédente
    //pour les inscrits à la newsletter on n'a aucune info utile seulement le mail
    if (is_array ($Tsql3))
    {
      foreach ($Tsql3 as $T3)
      {
        if (!in_array (trim ($T3['email']), $Temail_already_capted))
        {
          $Tdata = Array();
          $Tdata[] = $T3['email'];
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = '';
          $Tdata[] = 'PROSPECT';
          $Tdata[] = '';
          $Tdata[] = 1;
          $Tdata[] = '';
          $Tdata[] = '';
          //$Tdata[] = '';

          G_displayLine ($Tdata, false);
        }
      }
    }
  }

  exit (0);
}

function G_get_stamps ($id_customer)
{
  global $Tcache;
  if (!isset ($Tcache['HAS_LOYALTY']))
  {
    // Vérifier présence de la table ps_loyalty
    $Tcache['HAS_LOYALTY'] = false;

    $sql = 'desc ' . constant ('_DB_PREFIX_') . 'loyalty';
    $Tsql = Db::getInstance ()->ExecuteS ($sql);

    if (count ($Tsql) > 1)
      $Tcache['HAS_LOYALTY'] = true;
  }

  if ($Tcache['HAS_LOYALTY'])
  {
    // Faire la somme des 'points';  
    $sql = 'select sum(points) as NB from ' . constant ('_DB_PREFIX_') . 'loyalty l
            where l.id_loyalty_state=2 and l.id_customer=' . $id_customer;
    $Tsql = Db::getInstance ()->ExecuteS ($sql);

    // if ($Tsql===false)  echo $sql;
    if (isset ($Tsql[0]['NB']))
      return $Tsql[0]['NB'];
  }
  return 0;
}

function G_do_customer_sms ()
{
  global $id_lang;

  header ('Content-Type: text/csv; charset=iso-8859-1');
  header ('Content-Disposition: attachment; filename=export_sms_' . date ('dmY') . '_' . date ('His') . '.csv');
  $Theader = array("NOM", "PRENOM", "TELEPHONE", "PORTABLE", "EMAIL", "GROUPES");
  G_displayLine ($Theader, false);

  $Tsql = G_get_params_customer ();
  $Tsql[] = 'c.active = 1';
  $Tsql[] = 'c.deleted = 0';
  $where = join (' and ', $Tsql);

  # $sql = 'select id_customer, lastname, firstname, email  ' .
  #         'from ' . constant ('_DB_PREFIX_') . 'customer where active = 1';
  $sql = 'select id_customer, lastname, firstname, email  ' .
          'from ' . constant ('_DB_PREFIX_') . 'customer c where ' . $where;

  $Tsql = Db::getInstance ()->ExecuteS ($sql);
  foreach ($Tsql as $T)
  {
    $id_customer = $T['id_customer'];

    // Chargement des groupes.
    $sql = 'select name from '
            . constant ('_DB_PREFIX_') . 'customer_group cg, '
            . constant ('_DB_PREFIX_') . 'group_lang gl
              where gl.id_group=cg.id_group and gl.id_lang=\'' . $id_lang . '\' and cg.id_customer=\'' . $id_customer . '\'';
    $Tname_group = Db::getInstance ()->ExecuteS ($sql);
    $Td2 = array();
    foreach ($Tname_group as $Td)
    {
      if ($Td['name'] != '')
        $Td2[] = $Td['name'];
    }
    $groups = join (',', $Td2);
    // Chargements des adresses.
    $sql = 'select phone, phone_mobile from '
            . constant ('_DB_PREFIX_') . 'address
              where id_customer=\'' . $id_customer . '\' and active=1 and deleted=0';
    $Tphones = Db::getInstance ()->ExecuteS ($sql);

    $phone;
    $gsm = null;
    foreach ($Tphones as $Tphone)
    {
      if ($Tphone['phone_mobile'] != null)
        $gsm = $Tphone['phone_mobile'];
      if ($Tphone['phone'] != null)
      {
        // Numéro en 06 ou 07.
        if (preg_match ('/^0[67]/', $Tphone['phone']))
        {
          if ($gsm == null)
            $gsm = $Tphone['phone_mobile'];
        }
        else
          $phone = $Tphone['phone'];
      }
    }

    if ($gsm != null)
    {
      $Tdata = array();
      $Tdata[] = $T['lastname'];
      $Tdata[] = $T['firstname'];
      $Tdata[] = $phone;
      $Tdata[] = $gsm;
      $Tdata[] = $T['email'];
      $Tdata[] = $groups;

      G_displayLine ($Tdata, true); // Avec guillemet
    }
  }

  exit (0);
}

function G_do_product ($mode = 'EXTENDED')
{
  global $id_lang;
  $limit = 0;
  if (isset ($_REQUEST['limit']))
    $limit = (int) $_REQUEST['limit'];

  header ('Content-Type: text/csv; charset=iso-8859-1');
  header ('Content-Disposition: attachment; filename=export_product_' . date ('dmY') . '_' . date ('Hi') . '.csv');
  // Ligne d'entête
  if ($mode == 'EXTENDED')
  {
    $Theader = array(
        // "NOM_CAT",
        "EXTERNAL_REF_CAT",
        "REF", "REF_GENERIQUE",
        "LOCATION",
        "NOM",
        "PRIX", "PRIX2", "PRIX3", "TAUX_TVA", "PRIX_HT", "PRIX2_HT", "PRIX3_HT",
        "MARQUE", "REF_MARQUE", "TXT1", "TXT2", "TZOOM1", "TZOOM2", "COEFF", "AFFICHER",
        "VENTE", "DEBUT_DISPO", "FIN_DISPO", "QTE_IMPOSE", "LISTE", "SI", "SS1", "SS2",
        "ORDRE", 'G$_NOM_TAG_EVENT', 'NOM_TAG_NAVIGATION',
        #"REF_ARTICLE_ADDI", "REF_ARTICLE_EQUI", "REF_ARTICLE_BUND", "REF_ARTICLE_COMP",
        "SUPPLIER_CODE", "SUPPLIER_REF", "SUPPLIER_PRICE",
        'VIG', 'URL_EXTERNE', 'SA',
        'ADDITIONAL_TAX',
        'CODE_EAN', 'AVAIL_INFO', 'CELL_B2');
  }
  else
  {
    // Suppression de  "TXT1", "TXT2", "TZOOM1", "TZOOM2",
    $Theader = array(
        // "NOM_CAT",
        "EXTERNAL_REF_CAT",
        "REF", "REF_GENERIQUE",
        "LOCATION",
        "NOM",
        "PRIX", "PRIX2", "PRIX3", "TAUX_TVA", "PRIX_HT", "PRIX2_HT", "PRIX3_HT",
        "MARQUE", "REF_MARQUE", "COEFF", "AFFICHER",
        "VENTE", "DEBUT_DISPO", "FIN_DISPO", "QTE_IMPOSE", "LISTE", "SI", "SS1", "SS2",
        "ORDRE", 'G$_NOM_TAG_EVENT', 'NOM_TAG_NAVIGATION',
        "SUPPLIER_CODE", "SUPPLIER_REF", "SUPPLIER_PRICE",
        'VIG', 'URL_EXTERNE', 'SA',
        'ADDITIONAL_TAX',
        'CODE_EAN', 'AVAIL_INFO', 'CELL_B2');
  }

  // TODO: Manque IMG1 ... !
  // Liste des langues.
  $Tlanguages = Language::getLanguages (false);
  $lettre = 'C'; //on stocke les infos produits en fonction de la langue à partir de la colonne C 
  // car colonne A dédiée aux déclinaisons, et B aux données spécifiques
  foreach ($Tlanguages as $Tlanguage)
  {
    if ($Tlanguage["active"] == 1)
    {
      $Theader[] = 'CELL_' . $lettre . '1'; // Code langue
      $Theader[] = 'CELL_' . $lettre . '2'; // Nom produit
      $Theader[] = 'CELL_' . $lettre . '3'; // Prix 1 TTC dans la langue
      $Theader[] = 'CELL_' . $lettre . '4'; // Prix 1 HT dans la langue
      $Theader[] = 'CELL_' . $lettre . '5'; // Prix 2 TTC dans la langue
      $Theader[] = 'CELL_' . $lettre . '6'; // Prix 2 HT dans la langue
      $Theader[] = 'CELL_' . $lettre . '7'; // Devise
      $Theader[] = 'CELL_' . $lettre . '8'; // URL externe avec la langue

      $lettre++;
    }
  }

  G_displayLine ($Theader);

  // Caract.
  #$sql_colonne_feature = 'SELECT fl.name, fl.id_feature FROM ' . constant ('_DB_PREFIX_') . 'feature_lang fl WHERE fl.id_lang=' . $id_lang;
  #$sql_colonne_feature .= ' ORDER BY fl.id_feature ASC ';
  #$data_colonne_feature = Db::getInstance ()->ExecuteS ($sql_colonne_feature);
  //
  $sql = 'SELECT c.id_category, c.name FROM ' . constant ('_DB_PREFIX_') . 'category_lang c ' .
          'WHERE c.id_lang=' . $id_lang;
  $Tsql = Db::getInstance ()->ExecuteS ($sql);
  global $Tcat;
  $Tcat = array();
  foreach ($Tsql as $T)
  {
    $Tcat[$T['id_category']] = $T['name'];
  }

  if ($mode == 'EXTENDED')
    $sql_extended = 'pl.description, pl.description_short,';
  else
    $sql_extended = '';

  // Uniquement pour 1.4+
  // Récup des TVA.
  // Récup des groupes de TVA
  // Récup des pays
  //requete modifier temporairement pour fonctionner sur presta 1.3 (mais manque certaines infos comme prix2)
  if (version_compare (_PS_VERSION_, '1.4.0') == -1)
  {

    $sql_produit = "SELECT
    p.id_product,
    p.reference as reference_produit,
    p.id_supplier as supplier_code,
    p.reduction_price,
    p.reduction_percent,
    s.name as supplier_name,
    p.supplier_reference,
    p.on_sale,
    p.ean13,
    p.ecotax,
    p.quantity,
    p.price,
    p.wholesale_price,
    p.weight,
    p.id_category_default as category_id,
    p.active,
    t.rate as tax,
    pl.id_lang as lang,
    $sql_extended
    pl.name,
    pl.available_now,
    pl.available_later,
    pl.link_rewrite,
    m.name as manufacturer,
    (SELECT pi.id_image FROM " . constant ('_DB_PREFIX_') . 'image pi WHERE pi.id_product=p.id_product AND pi.cover=1 LIMIT 1) as id_image
    FROM ' . constant ('_DB_PREFIX_') . 'product p
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'product_lang pl ON p.id_product=pl.id_product
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'product_attribute pa ON (p.id_product=pa.id_product and pa.default_on=1)
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'manufacturer m ON m.id_manufacturer=p.id_manufacturer
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'supplier s ON s.id_supplier=p.id_supplier
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'tax t ON t.id_tax=p.id_tax
     ';
  }
  else//requete classique NP (fonctionne correctement sur presta 1.5
  {
    // Champ UPC pour PS >= 1.4
    $sql_produit = "SELECT
    p.id_product,
    p.reference as reference_produit,
    p.id_supplier as supplier_code,
    s.name as supplier_name,
    p.supplier_reference,
    p.on_sale,
    p.ean13,
    p.upc,
    p.ecotax,
    p.quantity,
    p.minimal_quantity,
    p.price,
    p.wholesale_price,
    p.weight,
    p.additional_shipping_cost,
    p.id_category_default as category_id,
    p.active,
    p.id_tax_rules_group,
    pl.id_lang as lang,
    $sql_extended
    pl.name,
    pl.available_now,
    pl.available_later,
    pl.link_rewrite,
    m.name as manufacturer,
    sp.reduction,
    sp.reduction_type,
    sp.from,
    sp.to,
    pa.id_product_attribute as default_id_product_attribute,
    (SELECT pi.id_image FROM " . constant ('_DB_PREFIX_') . 'image pi WHERE pi.id_product=p.id_product AND pi.cover=1 LIMIT 1) as id_image
    FROM ' . constant ('_DB_PREFIX_') . 'product p
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'specific_price sp ON p.id_product=sp.id_product
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'product_lang pl ON p.id_product=pl.id_product
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'product_attribute pa ON (p.id_product=pa.id_product and pa.default_on=1)
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'manufacturer m ON m.id_manufacturer=p.id_manufacturer
     LEFT JOIN ' . constant ('_DB_PREFIX_') . 'supplier s ON s.id_supplier=p.id_supplier
     ';
  }

  $Tsql = G_get_params_product ();
  $Tsql[] = 'pl.id_lang = ' . $id_lang;
  $Tsql[] = 'p.active = 1';
  $where = join (' and ', $Tsql);

  $sql_produit .= ' WHERE ' . $where;
  $sql_produit .= ' GROUP BY p.id_product';

  // Non pris en compte ! (Vérifier que le ExecuteS ne filtre pas le LIMIT)
  if ($limit > 1)
    $sql_produit .= ' LIMIT 0,' . (int) $limit;

  $liste_produit = Db::getInstance ()->ExecuteS ($sql_produit);

  $use_generique = true;
  if (is_array ($liste_produit))
  {
    foreach ($liste_produit as $Tdata)
    {
      // possibilité des infos écrasants celles du générique.
      if ($Tdata['default_id_product_attribute'] > 0)
      {
        $sql = 'SELECT id_image
            FROM ' . constant ('_DB_PREFIX_') . 'product_attribute_image
            WHERE id_product_attribute=' . $Tdata['default_id_product_attribute'];

        $T = Db::getInstance ()->ExecuteS ($sql);
        if (isset ($T['id_image']) and $T['id_image'] > 0)
          $Tdata['id_image'] = $T['id_image'];
      }

      if (!isset ($Tdata['tax']))
      {
        global $Tcache;
        if (!isset ($Tcache['tax_rule']))
          $Tcache['tax_rule'] = array();
        if (!isset ($Tcache['tax']))
          $Tcache['tax'] = array();

        // A mettre dans un cache.
        $Tdata['tax'] = 0;
        $Tdata['id_tax'] = 0;
        if ($Tdata['id_tax_rules_group'] > 0)
        {
          if (isset ($Tcache['tax_rule'][$Tdata['id_tax_rules_group']]))
          {
            $Tdata['id_tax'] = $Tcache['tax_rule'][$Tdata['id_tax_rules_group']];
          }
          else
          {
            $sql = 'SELECT min(id_tax) as ID
              FROM ' . constant ('_DB_PREFIX_') . 'tax_rule
              WHERE id_tax_rules_group=' . $Tdata['id_tax_rules_group'];

            $T = Db::getInstance ()->ExecuteS ($sql);
            if (isset ($T[0]['ID']) and $T[0]['ID'] > 0)
            {
              $Tdata['id_tax'] = $T[0]['ID'];
              $Tcache['tax_rule'][$Tdata['id_tax_rules_group']] = $Tdata['id_tax'];
            }
          }
        }
        if ($Tdata['id_tax'] > 0)
        {
          if (isset ($Tcache['tax'][$Tdata['id_tax']]))
          {
            $Tdata['tax'] = $Tcache['tax'][$Tdata['id_tax']];
          }
          else
          {
            $sql = 'SELECT rate
              FROM ' . constant ('_DB_PREFIX_') . 'tax
              WHERE id_tax=' . $Tdata['id_tax'];

            $T = Db::getInstance ()->ExecuteS ($sql);
            if (isset ($T[0]['rate']))
            {
              $Tdata['tax'] = $T[0]['rate'];
              $Tcache['tax'][$Tdata['id_tax']] = $Tdata['tax'];
            }
          }
        }
        #echo '// ' . $Tdata['id_tax'] . "\n";
        #echo '// ' . $Tdata['tax'] . "\n";
      }

      // Le générique (REF)
      $Tdata_product = G_getDataProduct ($Tdata, $Tlanguages, $mode);
      G_displayLine ($Tdata_product);

      if ($use_generique)
      {
        if ($Tdata['default_id_product_attribute'] > 0)
        {
          $Tdata_ref = $Tdata;
          $Tdata_ref['reference_produit_parent'] = $Tdata_ref['reference_produit'];
          $Tdata_ref['id_product_parent'] = $Tdata_ref['id_product'];

          $sql = 'SELECT * FROM ' . constant ('_DB_PREFIX_') . 'product_attribute WHERE id_product=' . $Tdata['id_product'];
          $T = Db::getInstance ()->ExecuteS ($sql);

          foreach ($T as $Tdata_attr)
          {
            $Tdata = $Tdata_ref;

            $Tdata['id_product_attribute'] = $Tdata_attr['id_product_attribute'];
            if (!empty ($Tdata_attr['reference']))
              $Tdata['reference'] = $Tdata_attr['reference'];
            $Tdata['ean13'] = $Tdata_attr['ean13'];
            $Tdata['upc'] = $Tdata_attr['upc'];

            if ($Tdata_attr['supplier_reference'] != null)
              $Tdata['supplier_reference'] = $Tdata_attr['supplier_reference'];
            if ($Tdata_attr['price'] > 0)
              $Tdata['price'] = $Tdata_attr['price'];
            if ($Tdata_attr['weight'] != '')
              $Tdata['weight'] = $Tdata_attr['weight'];
            if ($Tdata_attr['quantity'] > 0)
              $Tdata['quantity'] = $Tdata_attr['quantity'];
            if ($Tdata_attr['minimal_quantity'] > 0)
              $Tdata['minimal_quantity'] = $Tdata_attr['minimal_quantity'];

            // La déclinaison (REF_PARENT)
            $Tdata_product = G_getDataProduct ($Tdata, $Tlanguages, $mode);
            G_displayLine ($Tdata_product);
          }
        }
      }
    }
  }
  else
  {
    echo utf8_decode ("Erreur lors de la récupération des données");
  }

  exit (0);
}

function G_getDataProduct ($data, &$Tlanguages, $mode = 'EXTENDED')
{
  if (version_compare (_PS_VERSION_, '1.6.0') == -1)
    @include_once 'classes/Image.php';

  global $Tcat;
  global $id_lang;

  global $link;

  $Tdata = array();
  $Tprice = array();

  // $cat = $data['category'];
  $idcat = $data['category_id'];
  if (isset ($Tcat[$idcat]))
    $cat = $Tcat[$idcat];
  else
    $cat = $data['category'];

  $Tdata[] = $data['category_id']; // EXTERNAL_REF_CAT
  // $Tdata[] = $Tcat[$idcat]; // NOM_CAT

  $ref = $data['reference_produit'];
  global $Treferences;
  if ($ref != null and isset ($Treferences[$ref]))
    $ref = null;

  if ($ref == null)
  {
    $ref = sprintf ('G!%05d', $data['id_product']);
    if (!empty ($data['id_product_attribute']))
    {
      $ref .= sprintf ('-%05d', $data['id_product_attribute']);
    }
  }
  $Treferences[$ref] = true;
  $Tdata[] = $ref; // REF

  $ref_parent = '';
  if (isset ($data['reference_produit_parent']))
  {
    $ref_parent = $data['reference_produit_parent'];
    if ($ref_parent == null)
    {
      $ref_parent = sprintf ('G!%05d', $data['id_product_parent']);
    }
  }
  $Tdata[] = $ref_parent; // REF_GENERIQUE

  $location = $data['id_product']; // LOCATION
  if (!empty ($data['id_product_attribute']))
    $location .= '-' . $data['id_product_attribute']; // EXTERNAL_ID_GENERIQUE
  $Tdata[] = $location;

  $Tdata[] = $data['name']; // NOM

  $price = ($data['price']) + ($data['price'] * $data['tax'] / 100);
  $price = number_format (round ($price, 2), 2, '.', '');
  $Tdata[] = $price; // TTC // PRIX
  $Tprice["PRIX_TTC"] = $price;
  // Vérification date promo valide.
  $has_prix2 = false;
  $date_from = $data['from'];
  $date_to = $data['to'];
  $reduction = $data['reduction'];
  $reduction_type = $data['reduction_type'];
  $prix2 = '';
  $start_date = '';
  $end_date = '';

  if (version_compare (_PS_VERSION_, '1.4.0') == -1)//gestion de la réduction TTC pour Presta 1.3
  {
    if ($data["tax"] > 0)
      $prix1_ttc = $data["price"] * (1 + ($data["tax"] / 100));
    else
      $prix1_ttc = $data["price"];


    if ($data["reduction_price"] > 0)//cas d'une réduction en montant
    {
      $price2_ttc = $prix1_ttc - $data["reduction_price"];
      $prix2 = number_format (round ($price2_ttc, 2), 2, '.', ''); //TTC
      //$prix2 = $price2_ttc/(1+($data["tax"]/100));
      //$prix2 = number_format (round ($prix2, 2), 2, '.', '');
      $has_prix2 = TRUE;
    }
    else if ($data["reduction_percent"] > 0)//cas d'une réduction en pourcentage
    {
      $price2_ttc = $prix1_ttc - (($data["reduction_percent"] / 100) * $prix1_ttc);
      $prix2 = number_format (round ($price2_ttc, 2), 2, '.', ''); //TTC
      $has_prix2 = TRUE;
    }
    else
      $prix2 = 'NULL';
  }
  else//gestion réduction TTC pour Presta 1.4
  {
    if ($date_from == null and $date_to == null)
      $has_prix2 = false;
    else
    {
      $time = time ();

      $time_from = G_mktime ($date_from, 'UNIX');
      $time_to = G_mktime ($date_to, 'UNIX');

      if (($time_from == 0 or $time_from < $time) and ( $time_to == 0 or $time_to > $time))
      {
        $has_prix2 = true;
      }
    }

    if ($has_prix2)
    {
      $prix2 = $price; // TTC

      if ($reduction !== null)
      {
        if ($reduction_type == 'percentage')
          $prix2 -= $prix2 * $reduction;
        else
          $prix2 -= $reduction;
        $prix2 = number_format (round ($prix2, 2), 2, '.', '');
      }
      if ($prix2 >= $price)
      {
        $start_date = '';
        $end_date = '';
        $prix2 = 'NULL';
      }
      else
      {
        // Unixtime ? Pb TZ ?
        if ($data['from'] != '')
          $start_date = G_mktime ($data['from'], 'FR');
        if ($data['to'] != '')
          $end_date = G_mktime ($data['to'], 'FR');
      }
    }
    else
      $prix2 = 'NULL';
  }


  $Tdata[] = $prix2; // TTC // PRIX2
  $Tprice["PRIX2_TTC"] = $prix2;
  $Tdata[] = ''; // TTC // PRIX3

  $Tdata[] = number_format (round ($data['tax'], 2), 2, '.', ''); // TAUX_TVA
  $price = $data['price'];
  $Tdata[] = number_format (round ($price, 2), 2, '.', ''); // HT // PRIX_HT
  $Tprice["PRIX_HT"] = number_format (round ($price, 2), 2, '.', '');

  if (version_compare (_PS_VERSION_, '1.4.0') == -1)//gestion de la réduction HT pour Presta 1.3
  {
    if ($has_prix2)
    {
      $prix2 = $prix2 / (1 + ($data["tax"] / 100)); //HT
      $prix2 = number_format (round ($prix2, 2), 2, '.', '');
    }
    else
    {
      $prix2 = 'NULL';
    }
  }
  else//gestion de la réduction HT pour Presta 1.4
  {
    if ($has_prix2)
    {
      $prix2 = $price; // HT
      $reduction = $data['reduction'];
      $reduction_type = $data['reduction_type'];
      if ($reduction !== null)
      {
        if ($reduction_type == 'percentage')
          $prix2 -= $prix2 * $reduction;
        else
          $prix2 -= $reduction; // TTC : TODO: A mettre en HT !
        $prix2 = number_format (round ($prix2, 2), 2, '.', '');
      }
      if ($prix2 >= $price)
        $prix2 = 'NULL';
    }
    else
      $prix2 = 'NULL';
  }

  $Tdata[] = $prix2; // PRIX2_HT
  $Tprice["PRIX2_HT"] = $prix2;
  $Tdata[] = ''; // PRIX3_HT

  $Tdata[] = $data['manufacturer']; // MARQUE
  $Tdata[] = $data['supplier_reference']; // REF_MARQUE

  if ($mode == 'EXTENDED')
  {
    $Tdata[] = $data['description_short']; // TXT1
    $Tdata[] = $data['description']; // TXT2
    $Tdata[] = ''; // TZOOM1
    $Tdata[] = ''; // TZOOM2
  }

  $Tdata[] = $data['weight']; // COEFF
  $Tdata[] = $data['active']; // AFFICHER
  $Tdata[] = '1'; // $data['on_sale']; // VENTE
  $Tdata[] = $start_date; // DEBUT_DISPO
  $Tdata[] = $end_date; // FIN_DISPO
  $Tdata[] = $data['minimal_quantity']; // QTE_IMPOSE
  $Tdata[] = ''; // LISTE
  $Tdata[] = ''; // SI
  $Tdata[] = ''; // SS1
  $Tdata[] = ''; // SS2
  $Tdata[] = ''; // ORDRE

  $categories = G_getAllCategoriesByProduct ($data['id_product'], $id_lang, 'EVENT');
  $Tdata[] = $categories; // NOM_TAG_EVENT

  $categories = G_getAllCategoriesByProduct ($data['id_product'], $id_lang, 'NAVIGATION');
  $Tdata[] = $categories; // NOM_TAG_NAVIGATION
  #$Tdata[] = ''; // REF_ARTICLE_ADDI
  #$Tdata[] = ''; // REF_ARTICLE_EQUI
  #$Tdata[] = ''; // REF_ARTICLE_BUND
  #$Tdata[] = ''; // REF_ARTICLE_COMP
  //
  $Tdata[] = $data['supplier_name']; // SUPPLIER_CODE
  $Tdata[] = $data['supplier_reference']; // SUPPLIER_REF (idem que REF_MARQUE)
  $Tdata[] = $data['wholesale_price']; // SUPPLIER_PRICE
  // Plusieurs techniques de numérotation.
  if ($data['id_image'] > 0 or ! empty ($data['id_image']))
  {
    $image = '';

    if (!defined ('_PS_PROD_IMG_'))
      define ('_PS_PROD_IMG_', 'img/p/');

    #config/defines.inc.php:define('_PS_PROD_IMG_',                  'img/p/');
    #config/defines.inc.php:define('_PS_IMG_DIR_',              _PS_ROOT_DIR_.'/img/');
    #config/defines.inc.php:define('_PS_PROD_IMG_DIR_',         _PS_IMG_DIR_.'p/');

    $Cimage = new Image ($data['id_image']);
    // $new_path = _PS_PROD_IMG_DIR_ . $Cimage->getImgPath (); // getExistingImgPath ()

    $found = false;

    $size = 'large';
    if (method_exists ($Cimage, 'getExistingImgPath'))
    {
      $new_path = _PS_PROD_IMG_DIR_ . $Cimage->getExistingImgPath ();

      global $Tcache;
      if (isset ($Tcache['imagesTypes']))
      {
        $imagesTypes = $Tcache['imagesTypes'];
      }
      else
      {
        $imagesTypes = ImageType::getImagesTypes ('products');
        $Tcache['imagesTypes'] = $imagesTypes;
      }
      // TODO: Voir si large existe et si oui le garder, sinon prendre le premier de la liste.
      $size = 'large';
      if (isset ($imagesTypes[0]['name']))
      {
        $size = $imagesTypes[0]['name'];
      }

      // Recherche de l'image la plus grande et qui existe. (min(taille) avec taille > 150)
      // Avoir une liste de préférence de taille. La plus grande n'est pas forcément la meilleure.
      $maxsize = 0;
      $oldsize = 0;
      // TODO: demander la bonne taille.
      $asksize = 180; // Taille pour les NewsLetter.
      foreach ($imagesTypes as $Timage)
      {
        if ($Timage['width'] > $maxsize and $oldsize <= $asksize)
        {
          $maxsize = $Timage['width'];
          $size = $Timage['name'];

          if (file_exists ($new_path . "-$size.jpg"))
          {
            // 
            // $path = _PS_PROD_IMG_DIR_ . $image->getExistingImgPath().'.jpg'
            // 
            // $file3 = $Cimage->getImgPath () . "-$size.jpg";
            $file3 = $Cimage->getExistingImgPath () . "-$size.jpg"; // OK en PS4
            // config/config.inc.php
            // __PS_BASE_URI__ : getBaseURI() : $this->physical_uri.$this->virtual_uri;
            //                 : getBaseURL() : 'http://'.$this->domain.$this->getBaseURI();
            // define('_PS_PROD_IMG_',  'img/p/');
            //
            
            
            if (version_compare (_PS_VERSION_, '1.5.4') >= 0)
              $image = 'http://' . $_SERVER['HTTP_HOST'] . constant ('_PS_PROD_IMG_') . $file3;
            else
              $image = 'http://' . $_SERVER['HTTP_HOST'] . constant ('__PS_BASE_URI__') . constant ('_PS_PROD_IMG_') . $file3;

            #$image .= "(" . constant ('_PS_PROD_IMG_') . ")";    // 1.5.4+ : /DIRECTORY/img/p/
            #$image .= "{" . constant ('__PS_BASE_URI__') . "}";    // 1.5.4+ : /DIRECTORY/
            #$image .= '[' . $Cimage->getExistingImgPath () . ']';  // 1.5.4+ : x/y/xy

            $found = true;
            $oldsize = $Timage['width'];
          }
        }
      }
    }
    // Anciennes méthodes PS3 !
    if (!$found)
    {
      $imagesTypes = ImageType::getImagesTypes ('products');
      $size = 'large';
      $fileV1 = _PS_PROD_IMG_ . $data['id_product'] . '-' . $data['id_image'] . "-$size.jpg";
      $fileV2 = _PS_PROD_IMG_ . G_decomposeIdImage ($data['id_image']) . "-$size.jpg";

      // Compatibility with the old image filesystem
      if (Configuration::get ('PS_LEGACY_IMAGES'))
      {
        $file = $fileV1;
        $file2 = $fileV2;
        #$file = _PS_PROD_IMG_ . '$1-$2$3.jpg';
        #$file = _PS_PROD_IMG_ . '$1-$2.jpg';
      }

      if (version_compare (_PS_VERSION_, '1.4.3') == -1)
      {
        $file = $fileV1;
        $file2 = $fileV2;
      }
      else
      {
        $file = $fileV2;
        $file2 = $fileV1; // si déclinaisons ?
      }

      if (file_exists (_PS_ROOT_DIR_ . "/$file"))
      {
        $image = 'http://' . $_SERVER['HTTP_HOST'] . constant ('__PS_BASE_URI__') . $file;
      }
      else if (file_exists (_PS_ROOT_DIR_ . "/$file2"))
      {
        $image = 'http://' . $_SERVER['HTTP_HOST'] . constant ('__PS_BASE_URI__') . $file2;
      }
    }
    if ($image == '')
    {
      // Oups image pas trouvée, on laisse le préfixe pour traitement lors de l'import !      
      if (method_exists ($Cimage, 'getImgPath'))
        $file3 = _PS_PROD_IMG_ . $Cimage->getImgPath () . "-$size.jpg";
      else
      {
        $file3 = _PS_PROD_IMG_ . $data['id_product'] . '-' . $data['id_image'] . "-$size.jpg";
      }

      // + $imagesTypes = ImageType::getImagesTypes('products');
      $image = 'error://' . $_SERVER['HTTP_HOST'] . constant ('__PS_BASE_URI__') . $file3;
    }
  }
  else
  {
    $image = '';
  }
  $Tdata[] = $image; // VIG

  if (version_compare (_PS_VERSION_, '1.4.0') < 0)
  {
    // Construction manuelle
    $url = 'http://' . $_SERVER['HTTP_HOST'] . constant ('__PS_BASE_URI__') . 'product.php?id_product=' . $data['id_product'];
    // Construction via la classe Product
  }
  else
  {
    // Marche pas dans tous les cas.
    // OK PS1.4
    $p = new Product ($data['id_product'], true, $id_lang);
    $url = $link->getProductLink ($p, null, null, null, $id_lang);

    #$cat_link_rewrite = Category::getLinkRewrite ($data['category_id'], $id_lang);
    #if (!empty ($cat_link_rewrite))
    #  $data['category'] = $cat_link_rewrite;
    #else
    #{
    #  $c = new Category ($data['category_id']);
    #  $data['category'] = $c->getName ($id_lang);
    #}
    #$url = $link->getProductLink ($data['id_product'], $data['link_rewrite'], $data['category'], $data['ean13'], $id_lang);
  }
  $Tdata[] = $url; // URL_EXTERNE

  $Tdata[] = $data['quantity']; // SA

  $Tdata[] = $data['ecotax']; // ADDITIONAL_TAX
  $Tdata[] = $data['ean13']; // CODE_EAN

  $Tdata[] = $data['available_now']; // AVAIL_INFO
  $Tdata[] = $data['upc']; // UPC CELL_B2
  //devise par défaut de la boutique
  if (method_exists ('Currency', 'getDefaultCurrency'))
  {
    $Tcurrency = Currency::getDefaultCurrency ();
    $default_currency = $Tcurrency->iso_code;
  }
  else if (method_exists ('Currency', 'getCurrent'))
  {
    $Tcurrency = Currency::getCurrent ();
    $default_currency = $Tcurrency->iso_code;
  }
  else
  {
    $Tcurrency = Currency::getCurrency (Configuration::get ('PS_CURRENCY_DEFAULT'));
    $default_currency = $Tcurrency['iso_code'];
  }

  //noms des produits en fonction de la langue
  $sql = 'SELECT id_lang, name ' .
          'FROM ' . constant ('_DB_PREFIX_') . 'product_lang where id_product = ' . (int) $data['id_product'];
  $Tsql = Db::getInstance ()->ExecuteS ($sql);
  $Tname_by_lang = Array();
  foreach ($Tsql as $sql)
  {
    $Tname_by_lang[$sql["id_lang"]] = $sql["name"];
  }

  // Liste des langues.
  foreach ($Tlanguages as $Tlanguage)
  {
    if ($Tlanguage["active"] == 1)
    {
      $Tdata[] = $Tlanguage["id_lang"] . ':' . $Tlanguage['iso_code']; // Code langue
      $Tdata[] = $Tname_by_lang[$Tlanguage["id_lang"]]; // Nom produit
      $Tdata[] = $Tprice["PRIX_TTC"]; // Prix 1 TTC dans la langue
      $Tdata[] = $Tprice["PRIX_HT"]; // Prix 1 HT dans la langue
      $Tdata[] = $Tprice["PRIX2_TTC"]; // Prix 2 TTC dans la langue
      $Tdata[] = $Tprice["PRIX2_HT"]; // Prix 2 HT dans la langue
      $Tdata[] = $default_currency; // $device_langue; // Devise

      if (version_compare (_PS_VERSION_, '1.4.0') >= 0)
      {
        $p = new Product ($data['id_product'], true, $Tlanguage['id_lang']);
        $l = $link->getProductLink ($p, null, null, null, $Tlanguage['id_lang']);

        // PS 1.4 et 1.5 : format langue /xx/        
        #   $cat_link_rewrite = Category::getLinkRewrite ($data['category_id'], $Tlanguage['id_lang']);
        #   if (!empty ($cat_link_rewrite))
        #     $data['category'] = $cat_link_rewrite;
        #   else
        #   {
        #     $c = new Category ($data['category_id']);
        #     $data['category'] = $c->getName ($Tlanguage['id_lang']);
        #   }
        #   $l = $link->getProductLink ($data['id_product'], $data['link_rewrite'], $data['category'], $data['ean13'], $Tlanguage['id_lang']);
      }
      else
      {
        // PS 1.2 et 1.3, format langue : /lang-xx/
        if (version_compare (_PS_VERSION_, '1.3.0') >= 0)
        {
          // PS 1.3
          $c = new Category ($data['category_id']);
          $data['category'] = $c->getName ($Tlanguage['id_lang']);
          $l = $link->getProductLink ($data['id_product'], $data['link_rewrite'], $data['category'], $data['ean13'],
                  $Tlanguage['id_lang']);
          // Le répertoire langue est automatiquement ajouté pour la langue non par défaut.
          // On force pour la langue par défaut !
          if (!preg_match ('/lang-/', $l))
            $l = preg_replace ('~(https?://[\.\w]+/)~', '$1lang-' . $Tlanguage['iso_code'] . '/', $l);
        }
        else
        {
          // PS 1.2
          $c = new Category ($data['category_id']);
          $data['category'] = $c->getName ($Tlanguage['id_lang']);
          $l = $link->getProductLink ($data['id_product'], $data['link_rewrite'], $data['category'], $data['ean13']);
          // Ajout info sur la langue : ajouter /lang-xx/ - on teste juste que cela n'a pas déjà fait.
          if (!preg_match ('/lang-/', $l))
            $l = preg_replace ('~(https?://[\.\w]+/)~', '$1lang-' . $Tlanguage['iso_code'] . '/', $l);
        }
      }

      // if ((int)Configuration::get('PS_REWRITING_SETTINGS')==1)
      if (preg_match ('/id_product=\d+/', $l))
        $l .= '&id_lang=' . $Tlanguage['id_lang'];
      $Tdata[] = $l;
    }
  }

  return $Tdata;
}

function G_displayLine ($Tdata, $has_delim = true)
{
  $T = array();
  foreach ($Tdata as $s)
  {
    // On supprime les retours à la ligne et le séparateur.
    $s = preg_replace ("/[\r\n]+/", " ", $s);
    // Codage CSV avec "
    if ($has_delim)
      $s = preg_replace ('/"/', '""', $s);
    else
      $s = preg_replace ('/;/', ' ', $s);

    // Notice: iconv(): Detected an illegal character in input string in .../modules/gulliver/export.php on line 1474
    $s = @iconv ('UTF-8', 'ISO-8859-1//IGNORE//TRANSLIT', $s);
    if ($has_delim)
      $T[] = '"' . $s . '"';
    else
      $T[] = $s;
  }
  echo join (G_SEP, $T);
  echo G_EOL;
}

function G_decomposeIdImage ($idImage)
{
// echo "idImage:".$idImage."\n";
  $retour = '';
  for ($i = 0; $i < strlen ($idImage); $i++)
  {
    // echo "***".$idImage[$i]."\n";
    $retour .= '/' . $idImage[$i];
  }
  $retour .= '/' . $idImage;
// echo "\n".$retour."\n";
  return $retour;
}

function G_getNomCategorie ($id_cat, $id_lang)
{
  global $Tcache;
  if (isset ($Tcache['getNomCategorie']["$id_cat-$id_lang"]))
    return $Tcache['getNomCategorie']["$id_cat-$id_lang"];

  $sql = 'SELECT cl.name  as category_name ';
  $sql .='FROM ' . constant ('_DB_PREFIX_') . 'category_lang cl ';
  $sql .='WHERE cl.id_lang=' . $id_lang . ' AND cl.id_category=' . $id_cat;

  $Tdata = Db::getInstance ()->ExecuteS ($sql);
  $nom_cat = G_cleanNomCategorie ($Tdata[0]['category_name']);

  $ret = trim ($nom_cat);

  $Tcache['getNomCategorie']["$id_cat-$id_lang"] = $ret;

  return $ret;
}

function G_cleanNomCategorie ($nom)
{
  $nom_cat = preg_replace ("^[0-9]*^", '', $nom);
  $nom_cat = preg_replace ("^[-.]*^", '', $nom_cat);
  $nom_cat = trim ($nom_cat);
  return $nom_cat;
}

// type= EVENT ou NAVIGATION
function G_getAllCategoriesByProduct ($id_product, $id_lang, $type = 'EVENT')
{
  if (empty ($id_product))
    return '';

  global $Tcache;
  if (isset ($Tcache['getAllCategoriesByProduct']["$id_product-$id_lang-$type"]))
    return $Tcache['getAllCategoriesByProduct']["$id_product-$id_lang-$type"];

  $Tret = array();

  $sql = 'SELECT id_category FROM ' . constant ('_DB_PREFIX_') . 'category_product ' .
          'WHERE id_product=' . (int) $id_product;
  $Tcategories = Db::getInstance ()->ExecuteS ($sql);
  foreach ($Tcategories as $Tcategory)
  {
    // Uniquement les catégories commençant par G$...
    $n = trim (G_getNomCategorie ($Tcategory['id_category'], $id_lang));

    if (preg_match ('/^G\$/', $n) and $type == 'EVENT')
      $Tret[] = $n;
    if (!preg_match ('/^G\$/', $n) and $type == 'NAVIGATION')
      $Tret[] = $n;
  }

// Ne pas mettre d'espace après la virgule.
  $ret = join (',', $Tret);

  $Tcache['getAllCategoriesByProduct']["$id_product-$id_lang-$type"] = $ret;

  return $ret;
}

function G_mktime ($date, $output_format)
{
  if ($date == '0000-00-00 00:00:00')
    return '';

  $r = preg_match ('/^(....)-(..)-(..) (..):(..):(..)$/', $date, $T);
  $d = null;

  if ($r > 0)
  {
    $hour = $T[4];
    $minute = $T[5];
    $second = $T[6];
    $month = $T[2];
    $day = $T[3];
    $year = $T[1];

    if ($output_format == 'FR')
    {
      // Format Date FR
      $d = "$day/$month/$year $hour:$minute";
    }
    else
    {
      $d = mktime ($hour, $minute, $second, $month, $day, $year);
    }
  }

  return $d;
}

//Fonction qui retourne le code PAYS format ISO
//A partir du id_country issu de prestashop
function G_get_gta_country_from_prestashop_id_country ($id_country_presta)
{
  global $Tcache;
  if (isset ($Tcache['get_gta_country_from_prestashop_id_country'][$id_country_presta]))
    return $Tcache['get_gta_country_from_prestashop_id_country'][$id_country_presta];

  $sql = 'select iso_code ' .
          'from ' . constant ('_DB_PREFIX_') . 'country where id_country = ' . (int) $id_country_presta;
  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  $Tcache['get_gta_country_from_prestashop_id_country'][$id_country_presta] = $Tsql[0]['iso_code'];
  return $Tsql[0]['iso_code'];
}

//Fonction qui retourne le code PAYS ISO
//A partir du id_lang issu de prestashop
function G_get_iso_code_from_id_lang_prestashop ($id_lang)
{
  global $Tcache;
  if (isset ($Tcache['get_iso_code_from_id_lang_prestashop'][$id_lang]))
    return $Tcache['get_iso_code_from_id_lang_prestashop'][$id_lang];

  $sql = 'select iso_code ' .
          'from ' . constant ('_DB_PREFIX_') . 'lang where id_lang = ' . (int) $id_lang;
  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  $Tcache['get_iso_code_from_id_lang_prestashop'][$id_lang] = $Tsql[0]['iso_code'];
  return $Tsql[0]['iso_code'];
}

function G_do_search_order ()
{
  // TODO : gpc_magic...
  if (get_magic_quotes_gpc () == 1)
    $email = stripslashes ($_REQUEST ['email']);
  else
    $email = $_REQUEST ['email'];

  // 1. Trouver le id_customer
  $C = new Customer ();
  $Ccustomer = $C->getByEmail ($email);
  $id_customer = $Ccustomer->id;

  if ($id_customer > 0)
  {
    // 2. Trouver la derniere commande.
    $Torders = Order::getCustomerOrders ($id_customer);
    $nb_orders = count ($Torders);

    // 3. Vérifier la date.
    $date = 0;
    $id_order = 0;
    $module = '';
    $id_order_state = '';
    $order_state = '';
    $commercial = '';
    foreach ($Torders as $Torder)
    {
      $d = $Torder['date_add'];
      if ($d > $date)
      {
        $id_order = $Torder['id_order'];
        $module = $Torder['module'];
        $id_order_state = $Torder['id_order_state'];
        $order_state = $Torder['order_state'];
        $date = $d;
        $commercial = '';
        
        $order = new Order((int)$id_order);
        // Attention version PS ?
        if (method_exists ($order, 'getCartRules'))
        {
          $T = $order->getCartRules ();
          if (!empty ($T[0]))
          {
            $id_cart_rule = $T[0]['id_cart_rule'];
            if (class_exists ('CartRule'))
            {
              $obj_cart_rule = new CartRule ((int)$id_cart_rule);
              $obj_currency = new Currency((int)$order->id_currency);
              $currency = $obj_currency->sign; // encodage ?
              $code = $obj_cart_rule->code;
              if (!empty ($code))
              {
                $commercial = $code;
                // $commercial .= '-' . $T[0]['name'];
                $commercial .= ':' . $T[0]['value'];
                $commercial .= '/' . $T[0]['value_tax_excl'];
                $commercial .= '/' . $T[0]['free_shipping'];
                $commercial .= '/' . $currency;
      }
    }
          }
        }
      }
    }

    echo "$email;$id_customer;$nb_orders;$id_order;$date;$module;$id_order_state;$order_state;$commercial\n";
  }
  else
  {
    echo "$email;0;0;0;;;;;\n";
  }

  exit (0);
}

//Export commandes
function G_do_orders ()
{
  $Tsql = G_get_params_order ();
  $where = join (' and ', $Tsql);
  if (!empty ($where))
    $where = " WHERE $where ";

  $sql = 'SELECT o.id_order, o.id_carrier, o.id_lang, o.id_customer, o.id_cart, o.id_currency, o.id_address_delivery,
                 o.id_address_invoice, o.payment, o.module, o.total_discounts, o.total_paid, o.total_paid_real, o.total_products,
                 o.total_products_wt, o.total_shipping, o.carrier_tax_rate, o.total_wrapping, o.date_add, o.valid,
                 od.tax_rate,
                 ca.name as shipping_name,
                 c.email as billing_email,
                 cu.iso_code as currency_code,
                 ad.company as delivery_company, ad.lastname as delivery_lastname, ad.firstname as delivery_firstname, ad.address1 as delivery_address1, ad.address2 as delivery_address2, ad.postcode as delivery_postcode, ad.city as delivery_city, ad.id_country as delivery_id_country, ad.phone as delivery_phone,
                 ad2.company as billing_company, ad2.lastname as billing_lastname, ad2.firstname as billing_firstname, ad2.address1 as billing_address1, ad2.address2 as billing_address2, ad2.postcode as billing_postcode, ad2.city as billing_city, ad2.id_country as billing_id_country, ad2.phone as billing_phone
          FROM ' . constant ('_DB_PREFIX_') . 'orders o
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'order_detail od ON od.id_order = o.id_order
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'carrier ca ON  ca.id_carrier = o.id_carrier
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'customer c ON  c.id_customer = o.id_customer
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'currency cu ON  cu.id_currency = o.id_currency
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'address ad ON  ad.id_address = o.id_address_delivery
          LEFT JOIN ' . constant ('_DB_PREFIX_') . 'address ad2 ON  ad2.id_address = o.id_address_invoice' .
          $where .
          ' ORDER BY o.date_add asc';

  $Tsql = Db::getInstance ()->ExecuteS ($sql);

  Header ('Content-Type: text/xml');
  if (empty ($where))
    header ('Content-Disposition: attachment; filename=export_all_orders_' . date ('dmY') . '_' . date ('His') . '.xml');
  else
    header ('Content-Disposition: attachment; filename=export_orders_' . date ('dmY') . '_' . date ('His') . '.xml');

  echo <<<EOT
<?xml version="1.0" encoding="UTF-8" ?>
<GulliverExport>
  <SaleOrderList>
  
EOT;


  $XML_SaleOrderlist = '';
  foreach ($Tsql as $sql)
  {
    $id_order_presta = G_XE ($sql["id_order"]);
    $order_date = G_XE ($sql["date_add"]);

    $customer_lastname = G_XE ($sql["billing_lastname"]);
    $customer_firstname = G_XE ($sql["billing_firstname"]);
    $customer_addressline1 = G_XE ($sql["billing_address1"]);
    $customer_addressline2 = G_XE ($sql["billing_address2"]);
    $customer_postcode = G_XE ($sql["billing_postcode"]);
    $customer_city = G_XE ($sql["billing_city"]);
    $customer_company = G_XE ($sql["billing_company"]);
    $customer_country = G_get_gta_country_from_prestashop_id_country (G_XE ($sql["billing_id_country"]));
    $customer_phone = G_XE ($sql["billing_phone"]);
    $customer_email = G_XE ($sql["billing_email"]);

    $delivery_lastname = G_XE ($sql["delivery_lastname"]);
    $delivery_firstname = G_XE ($sql["delivery_firstname"]);
    $delivery_addressline1 = G_XE ($sql["delivery_address1"]);
    $delivery_addressline2 = G_XE ($sql["delivery_address2"]);
    $delivery_city = G_XE ($sql["delivery_city"]);
    $delivery_postcode = G_XE ($sql["delivery_postcode"]);
    $delivery_country = G_get_gta_country_from_prestashop_id_country (G_XE ($sql["delivery_id_country"]));

    $total_amount = G_XE ($sql["total_paid"]);
    $currency_code = G_XE ($sql["currency_code"]);

    $discount_amount = G_XE ($sql["total_discounts"]);

    $payment_amount = G_XE ($sql["total_paid_real"]);
    $payment_name = G_XE ($sql["payment"]);
    $payment_method = G_XE ($sql["module"]);
    $amount_without_shipping = $payment_amount - G_XE ($sql["total_shipping"]);
    $amount_without_tax = number_format (($payment_amount / (1 + (G_XE ($sql["tax_rate"] / 100)))), 2, '.', ' ');

    $shipping_amount = G_XE ($sql["total_shipping"]);
    $shipping_name = G_XE ($sql["shipping_name"]);

    if ($sql["valid"] == 1)
      $payment_state = 'Valide';
    else
      $payment_state = '';

    // TODO: les produits !

    echo <<<EOT
<SaleOrder>

  <OrderNumber>$id_order_presta</OrderNumber>
  <OrderDate>$order_date</OrderDate>

  <CustomerInfo>
    <LastName>$customer_lastname</LastName>
    <FirstName>$customer_firstname</FirstName>
    <AddressLine1>$customer_addressline1</AddressLine1>
    <AddressLine2>$customer_addressline2</AddressLine2>
    <PhoneNumber>$customer_phone</PhoneNumber>
    <Email>$customer_email</Email>
    <City>$customer_city</City>
    <PostCode>$customer_postcode</PostCode>
    <CountryCode>$customer_country</CountryCode>
    <Company>$customer_company</Company>
  </CustomerInfo>

  <DeliveryInfo>
    <LastName>$delivery_lastname</LastName>
    <FirstName>$delivery_firstname</FirstName>
    <AddressLine1>$delivery_addressline1</AddressLine1>
    <AddressLine2>$delivery_addressline2</AddressLine2>
    <City>$delivery_city</City>
    <PostCode>$delivery_postcode</PostCode>
    <CountryCode>$delivery_country</CountryCode>
  </DeliveryInfo>

  <TotalAmount>$total_amount</TotalAmount>
  <Discount>$discount_amount</Discount>
  <CurrencyCode>$currency_code</CurrencyCode>
  <PaymentState>$payment_state</PaymentState>

  <PaymentList>
    <Payment>
      <PaymentMethod>$payment_method</PaymentMethod>
      <PaymentTitle>$payment_name</PaymentTitle>
      <PaymentValue>$payment_amount $currency_code</PaymentValue>
      <Amount>$payment_amount</Amount>
      <Amount_Without_Tax>$amount_without_tax</Amount_Without_Tax>
      <Amount_Without_Shipping>$amount_without_shipping</Amount_Without_Shipping>
    </Payment>
  </PaymentList>

  <ShippingCostList>
    <ShippingCost>
      <ShippingCode>$shipping_name</ShippingCode>
      <ShippingAmount>$shipping_amount</ShippingAmount>
      <ShippingDescription></ShippingDescription>
    </ShippingCost>
  </ShippingCostList>

</SaleOrder>
EOT;
  }

  //o.valid => 1 si paiment OK / 0 sinon

  echo <<<EOT
  
  </SaleOrderList>
</GulliverExport>
EOT;

  exit (0);
}

//Parsing XML
function G_XE ($_value)
{
  // $_value = utf8_encode ($_value);
  // Suppression des caractères de contrôle
  $_value = preg_replace ('/[\x0-\x1f]/', ' ', $_value);
  $_value = str_replace ('<', '&lt;', $_value);
  $_value = str_replace ('>', '&gt;', $_value);
  $_value = str_replace ('&', '&amp;', $_value);
  # pose probleme a ABDR dans leur decodage...
  # $_value = str_replace ("'", '&#39;', $_value);
  # $_value = str_replace ('"', '&#34;', $_value);
  # Less-Than [ < ]    : "&#60;"
  # Greater-Than [ > ] : "&#62;"
  # Ampersand [ & ]    : "&#38;"
  # Apostrophe [ ' ]   : "&#39;"
  # Quote [ " ]        : "&#34;"
  # Non Breaking Space (a forced space) : "&#32;"
  # Emdash [ -- ]      : "&#045;&#045;"

  return $_value;
}
